#include <iostream>
#include <stdlib.h>

#include "SDL.h"

using namespace std;

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel);
Uint32 getpixel(SDL_Surface *surface, int x, int y);
int main(int argc, char *argv[])
{
 bool quit=false;
 SDL_Surface * screen;
 SDL_Event  Event;
 int bpp,width,height,x,y,subtotal;
 SDL_Color palete[256];
 float alfa = 0;
 int x1, y1, x2, y2, x3, y3, x4, y4, x5, y5, x6, y6,cont;
 Uint32 tempix;
 
 
 SDL_Init ( SDL_INIT_VIDEO );
 bpp=16;
 width=320;
 height=240;
 
 
 
 float tabla[width][height];
 
 for (y=0; y<height; y++)
    {
        for (x=0; x<width; x++)
        {
            // 35156250
            if ((!x) && (!y)) tabla[y][x] = 9000000000/7000000;
            else tabla[y][x] = (9000000000.0 / (sqrt((float)x*x + y*y) * 7000000.0));
        }
    }
 
        
 for (cont=0; cont<64; cont++){
  palete[cont].r=0;
  palete[cont].g=0;
  palete[cont].b=cont;
  
 }
 for (cont=0; cont<128; cont++){
  palete[cont+64].r=0;
  palete[cont+64].g=cont/2;
  palete[cont+64].b=63;
  
 }
 
 for (cont=0; cont<64; cont++){
  palete[cont+192].r=cont;
  palete[cont+192].g=63;
  palete[cont+192].b=63;
  
 }
 
 SDL_ShowCursor(SDL_FALSE);
 SDL_WM_GrabInput(SDL_GRAB_ON);
 
 screen=SDL_SetVideoMode(width,height,bpp,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
 
 if(bpp==8)
 SDL_SetPalette(screen, SDL_LOGPAL|SDL_PHYSPAL, palete, 0, 256);
 
 SDL_SetGamma(2.5, 2.5, 3.5);
 
 while(!quit){
     SDL_PollEvent(&Event); 
     switch(Event.type){  
      case SDL_KEYDOWN:       
      quit=true;
      break; 
      
      case SDL_MOUSEMOTION:
       if(Event.motion.xrel<50)
      quit=true;
      break;
      
      default:
      break;
      
      }
      
        float p_cos,n_cos,p2_cos,p_sin,n_sin,p2_sin;
        
        p_cos  = cos  (  alfa);   p_sin  = sin (  alfa);
        n_cos  = cos  ( -alfa);   n_sin  = sin ( -alfa);
        p2_cos = cos  (2*alfa);   p2_sin = sin (2*alfa);
        
        
        
        
        
        
        x1 = int( 60 * p_cos         + 30 * n_sin   +  width/2);
        y1 = int( 30 * cos (-alfa*2) + 60 * p_sin   + height/2);
        x2 = int( 30 * p_cos         + 60 * p2_sin  +  width/2);
        y2 = int( 60 * p_cos         + 30 * p_sin   + height/2);
        x3 = int( 45 * n_cos         + 45 * p_sin   +  width/2);
        y3 = int( 45 * p2_cos        + 45 * n_sin   + height/2);
        x4 = int( 75 * p_cos         + 15 * p2_sin  +  width/2);
        y4 = int( 15 * n_cos         + 75 * p2_sin  + height/2);
        x5 = int( 35 * p_cos         + 10 * p_sin   +  width/2);
        y5 = int( 10 * p2_cos        + 35 * n_sin   + height/2);
        x6 = int( 40 * n_cos         + 30 * p2_sin  +  width/2);
        y6 = int( 40 * p_cos         + 10 * p_sin   + height/2);
        
        alfa += 0.025;
        
  SDL_LockSurface(screen);
  
  for (y=0; y<height; y=y+2) {
    for (x=0; x<width; x=x+2)  {
      subtotal = int( tabla[ abs((y1-y)) ] [ abs(x1-x) ] 
                           + tabla[ abs((y2-y)) ] [ abs(x2-x) ]
                           + tabla[ abs((y3-y)) ] [ abs(x3-x) ]
                           + tabla[ abs((y4-y)) ] [ abs(x4-x) ]
                           + tabla[ abs((y5-y)) ] [ abs(x5-x) ]
                           + tabla[ abs((y6-y)) ] [ abs(x6-x) ] );
      
      if (subtotal > 255) subtotal = 255;
      
      if(bpp==8)
      {Uint8 *p=(Uint8 *)screen->pixels + y * screen->pitch + x * screen->format->BytesPerPixel;
      *p=subtotal;
      p++;
      *p=subtotal;
      p--;
      p=p+screen->pitch;
      *p=subtotal;
      p++;
      *p=subtotal;
      }
      else{
      putpixel(screen,x,y,SDL_MapRGB(screen->format, palete[subtotal].r, palete[subtotal].g,palete[subtotal].b));
      putpixel(screen,x+1,y,SDL_MapRGB(screen->format, palete[subtotal].r, palete[subtotal].g,palete[subtotal].b));
      putpixel(screen,x,y+1,SDL_MapRGB(screen->format, palete[subtotal].r, palete[subtotal].g,palete[subtotal].b));
      putpixel(screen,x+1,y+1,SDL_MapRGB(screen->format, palete[subtotal].r, palete[subtotal].g,palete[subtotal].b));
         
          
            }
      } 
    }
    
  SDL_UnlockSurface(screen);
  SDL_Flip(screen);
  SDL_Delay(10);
 }
 
 SDL_Quit();

  return 0;
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
   
    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}


Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}
